1087 Super Jumping! Jumping! Jumping!

来源:互联网 发布:js向下取整 编辑:程序博客网 时间:2024/05/20 04:49
Description
Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.



The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path.
Your task is to output the maximum value according to the given chessmen list.
Input
Input contains multiple test cases. Each test case is described in a line as follow:
N value_1 value_2 …value_N
It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.
A test case starting with 0 terminates the input and this test case is not to be processed.
Output
For each case, print the maximum according to rules, and one line one case.
SampleInput
3 1 3 24 1 2 3 44 3 3 2 10
SampleOutput
4103
解释一下题意:此题就是找序列中最大升序子序列的和。
比如  1 3 2 中升序序列有:{1}{3}{2}{1,3}{1,2}。所以最大为1+3=4;
 
dp[i]表示以i结尾的升序子序列的最大和,所以最后要比较所有的dp[i]。
用两个循环第一个循环(i)指定第i个元素a[i]
第二个循环(j)从头开始找如果a[i]>a[j] 就令dp[j]暂时为前段的最大值dns
继续向后找如果再次a[i]>a[j]则需比较dp[j]与dns的大小即max(dp[j],dns)找到新的dns

直到j为i前面的那个元素循环结束 dp[i]=ans+a[i]


# include <iostream>
# include<cstdio>
# define LL long long
using namespace std;


int main()
{
    int n,ans,max,i,j;
    int s[1005],a[1005];    //s[i]表示最末尾是a[i]这个数的结果
    bool flag;
    while(scanf("%d",&n)&& n)
    {
        for(i=0; i<n; i++)
        {
            scanf("%d",&a[i]);
            s[i] = 0;
        }
        s[0] = a[0];
        for(i=1; i<n; i++)
        {
            s[i] = a[i];
            for(j=0; j<i; j++)
            {
                if(a[i]>a[j] && s[j]+a[i]>s[i])
                {
                    s[i] = s[j] + a[i];
                }
            }
        }
        max = 0;
        for(i=0;i<n;i++)
        {
            if(s[i]>max)
            max = s[i];
        }
        printf("%d\n",max);
    }
    return 0;
}





0 0
原创粉丝点击